part of rad_textures;

final v0 = new Vector3.zero();
final distance = new Vector3.zero();

double worley1(double x, double y, double z) {
  const limit = 1.0;
  var min_distance_2 = 0.0;
  var min_distance = 0.0;

  v0.setValues(x, y, z);

  for(double offset_x = -limit; offset_x <= limit; offset_x += 1.0)
    for(double offset_y = -limit; offset_y <= limit; offset_y += 1.0)
      for(double offset_z = -limit; offset_z <= limit; offset_z += 1.0) {
        var v1 = PCellNoise3(x + offset_x, y + offset_y, z + offset_z);
        distance.setValues(x.floor() + offset_x, y.floor() + offset_y, z.floor() + offset_z);
        distance.add(v1);
        distance.sub(v0);
        if(min_distance_2 == 0.0) {
          min_distance_2 = distance.length2;
          min_distance = distance.length;
        } else {
          var length2 = distance.length2;
          if(min_distance_2 > length2) {
            min_distance_2 = length2;
            min_distance = distance.length;
          }
        }
      }
  return min_distance;
}